// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"somegit.dev/csgowtf/csgowtfd/ent/matchplayer"
	"somegit.dev/csgowtf/csgowtfd/ent/messages"
	"somegit.dev/csgowtf/csgowtfd/ent/predicate"
)

// MessagesUpdate is the builder for updating Messages entities.
type MessagesUpdate struct {
	config
	hooks     []Hook
	mutation  *MessagesMutation
	modifiers []func(*sql.UpdateBuilder)
}

// Where appends a list predicates to the MessagesUpdate builder.
func (mu *MessagesUpdate) Where(ps ...predicate.Messages) *MessagesUpdate {
	mu.mutation.Where(ps...)
	return mu
}

// SetMessage sets the "message" field.
func (mu *MessagesUpdate) SetMessage(s string) *MessagesUpdate {
	mu.mutation.SetMessage(s)
	return mu
}

// SetAllChat sets the "all_chat" field.
func (mu *MessagesUpdate) SetAllChat(b bool) *MessagesUpdate {
	mu.mutation.SetAllChat(b)
	return mu
}

// SetTick sets the "tick" field.
func (mu *MessagesUpdate) SetTick(i int) *MessagesUpdate {
	mu.mutation.ResetTick()
	mu.mutation.SetTick(i)
	return mu
}

// AddTick adds i to the "tick" field.
func (mu *MessagesUpdate) AddTick(i int) *MessagesUpdate {
	mu.mutation.AddTick(i)
	return mu
}

// SetMatchPlayerID sets the "match_player" edge to the MatchPlayer entity by ID.
func (mu *MessagesUpdate) SetMatchPlayerID(id int) *MessagesUpdate {
	mu.mutation.SetMatchPlayerID(id)
	return mu
}

// SetNillableMatchPlayerID sets the "match_player" edge to the MatchPlayer entity by ID if the given value is not nil.
func (mu *MessagesUpdate) SetNillableMatchPlayerID(id *int) *MessagesUpdate {
	if id != nil {
		mu = mu.SetMatchPlayerID(*id)
	}
	return mu
}

// SetMatchPlayer sets the "match_player" edge to the MatchPlayer entity.
func (mu *MessagesUpdate) SetMatchPlayer(m *MatchPlayer) *MessagesUpdate {
	return mu.SetMatchPlayerID(m.ID)
}

// Mutation returns the MessagesMutation object of the builder.
func (mu *MessagesUpdate) Mutation() *MessagesMutation {
	return mu.mutation
}

// ClearMatchPlayer clears the "match_player" edge to the MatchPlayer entity.
func (mu *MessagesUpdate) ClearMatchPlayer() *MessagesUpdate {
	mu.mutation.ClearMatchPlayer()
	return mu
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (mu *MessagesUpdate) Save(ctx context.Context) (int, error) {
	return withHooks(ctx, mu.sqlSave, mu.mutation, mu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (mu *MessagesUpdate) SaveX(ctx context.Context) int {
	affected, err := mu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (mu *MessagesUpdate) Exec(ctx context.Context) error {
	_, err := mu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (mu *MessagesUpdate) ExecX(ctx context.Context) {
	if err := mu.Exec(ctx); err != nil {
		panic(err)
	}
}

// Modify adds a statement modifier for attaching custom logic to the UPDATE statement.
func (mu *MessagesUpdate) Modify(modifiers ...func(u *sql.UpdateBuilder)) *MessagesUpdate {
	mu.modifiers = append(mu.modifiers, modifiers...)
	return mu
}

func (mu *MessagesUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := sqlgraph.NewUpdateSpec(messages.Table, messages.Columns, sqlgraph.NewFieldSpec(messages.FieldID, field.TypeInt))
	if ps := mu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := mu.mutation.Message(); ok {
		_spec.SetField(messages.FieldMessage, field.TypeString, value)
	}
	if value, ok := mu.mutation.AllChat(); ok {
		_spec.SetField(messages.FieldAllChat, field.TypeBool, value)
	}
	if value, ok := mu.mutation.Tick(); ok {
		_spec.SetField(messages.FieldTick, field.TypeInt, value)
	}
	if value, ok := mu.mutation.AddedTick(); ok {
		_spec.AddField(messages.FieldTick, field.TypeInt, value)
	}
	if mu.mutation.MatchPlayerCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   messages.MatchPlayerTable,
			Columns: []string{messages.MatchPlayerColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(matchplayer.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := mu.mutation.MatchPlayerIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   messages.MatchPlayerTable,
			Columns: []string{messages.MatchPlayerColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(matchplayer.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_spec.AddModifiers(mu.modifiers...)
	if n, err = sqlgraph.UpdateNodes(ctx, mu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{messages.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	mu.mutation.done = true
	return n, nil
}

// MessagesUpdateOne is the builder for updating a single Messages entity.
type MessagesUpdateOne struct {
	config
	fields    []string
	hooks     []Hook
	mutation  *MessagesMutation
	modifiers []func(*sql.UpdateBuilder)
}

// SetMessage sets the "message" field.
func (muo *MessagesUpdateOne) SetMessage(s string) *MessagesUpdateOne {
	muo.mutation.SetMessage(s)
	return muo
}

// SetAllChat sets the "all_chat" field.
func (muo *MessagesUpdateOne) SetAllChat(b bool) *MessagesUpdateOne {
	muo.mutation.SetAllChat(b)
	return muo
}

// SetTick sets the "tick" field.
func (muo *MessagesUpdateOne) SetTick(i int) *MessagesUpdateOne {
	muo.mutation.ResetTick()
	muo.mutation.SetTick(i)
	return muo
}

// AddTick adds i to the "tick" field.
func (muo *MessagesUpdateOne) AddTick(i int) *MessagesUpdateOne {
	muo.mutation.AddTick(i)
	return muo
}

// SetMatchPlayerID sets the "match_player" edge to the MatchPlayer entity by ID.
func (muo *MessagesUpdateOne) SetMatchPlayerID(id int) *MessagesUpdateOne {
	muo.mutation.SetMatchPlayerID(id)
	return muo
}

// SetNillableMatchPlayerID sets the "match_player" edge to the MatchPlayer entity by ID if the given value is not nil.
func (muo *MessagesUpdateOne) SetNillableMatchPlayerID(id *int) *MessagesUpdateOne {
	if id != nil {
		muo = muo.SetMatchPlayerID(*id)
	}
	return muo
}

// SetMatchPlayer sets the "match_player" edge to the MatchPlayer entity.
func (muo *MessagesUpdateOne) SetMatchPlayer(m *MatchPlayer) *MessagesUpdateOne {
	return muo.SetMatchPlayerID(m.ID)
}

// Mutation returns the MessagesMutation object of the builder.
func (muo *MessagesUpdateOne) Mutation() *MessagesMutation {
	return muo.mutation
}

// ClearMatchPlayer clears the "match_player" edge to the MatchPlayer entity.
func (muo *MessagesUpdateOne) ClearMatchPlayer() *MessagesUpdateOne {
	muo.mutation.ClearMatchPlayer()
	return muo
}

// Where appends a list predicates to the MessagesUpdate builder.
func (muo *MessagesUpdateOne) Where(ps ...predicate.Messages) *MessagesUpdateOne {
	muo.mutation.Where(ps...)
	return muo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (muo *MessagesUpdateOne) Select(field string, fields ...string) *MessagesUpdateOne {
	muo.fields = append([]string{field}, fields...)
	return muo
}

// Save executes the query and returns the updated Messages entity.
func (muo *MessagesUpdateOne) Save(ctx context.Context) (*Messages, error) {
	return withHooks(ctx, muo.sqlSave, muo.mutation, muo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (muo *MessagesUpdateOne) SaveX(ctx context.Context) *Messages {
	node, err := muo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (muo *MessagesUpdateOne) Exec(ctx context.Context) error {
	_, err := muo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (muo *MessagesUpdateOne) ExecX(ctx context.Context) {
	if err := muo.Exec(ctx); err != nil {
		panic(err)
	}
}

// Modify adds a statement modifier for attaching custom logic to the UPDATE statement.
func (muo *MessagesUpdateOne) Modify(modifiers ...func(u *sql.UpdateBuilder)) *MessagesUpdateOne {
	muo.modifiers = append(muo.modifiers, modifiers...)
	return muo
}

func (muo *MessagesUpdateOne) sqlSave(ctx context.Context) (_node *Messages, err error) {
	_spec := sqlgraph.NewUpdateSpec(messages.Table, messages.Columns, sqlgraph.NewFieldSpec(messages.FieldID, field.TypeInt))
	id, ok := muo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Messages.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := muo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, messages.FieldID)
		for _, f := range fields {
			if !messages.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != messages.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := muo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := muo.mutation.Message(); ok {
		_spec.SetField(messages.FieldMessage, field.TypeString, value)
	}
	if value, ok := muo.mutation.AllChat(); ok {
		_spec.SetField(messages.FieldAllChat, field.TypeBool, value)
	}
	if value, ok := muo.mutation.Tick(); ok {
		_spec.SetField(messages.FieldTick, field.TypeInt, value)
	}
	if value, ok := muo.mutation.AddedTick(); ok {
		_spec.AddField(messages.FieldTick, field.TypeInt, value)
	}
	if muo.mutation.MatchPlayerCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   messages.MatchPlayerTable,
			Columns: []string{messages.MatchPlayerColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(matchplayer.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := muo.mutation.MatchPlayerIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   messages.MatchPlayerTable,
			Columns: []string{messages.MatchPlayerColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(matchplayer.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_spec.AddModifiers(muo.modifiers...)
	_node = &Messages{config: muo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, muo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{messages.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	muo.mutation.done = true
	return _node, nil
}
