// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"somegit.dev/csgowtf/csgowtfd/ent/match"
	"somegit.dev/csgowtf/csgowtfd/ent/matchplayer"
	"somegit.dev/csgowtf/csgowtfd/ent/player"
)

// PlayerCreate is the builder for creating a Player entity.
type PlayerCreate struct {
	config
	mutation *PlayerMutation
	hooks    []Hook
}

// SetName sets the "name" field.
func (pc *PlayerCreate) SetName(s string) *PlayerCreate {
	pc.mutation.SetName(s)
	return pc
}

// SetNillableName sets the "name" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableName(s *string) *PlayerCreate {
	if s != nil {
		pc.SetName(*s)
	}
	return pc
}

// SetAvatar sets the "avatar" field.
func (pc *PlayerCreate) SetAvatar(s string) *PlayerCreate {
	pc.mutation.SetAvatar(s)
	return pc
}

// SetNillableAvatar sets the "avatar" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableAvatar(s *string) *PlayerCreate {
	if s != nil {
		pc.SetAvatar(*s)
	}
	return pc
}

// SetVanityURL sets the "vanity_url" field.
func (pc *PlayerCreate) SetVanityURL(s string) *PlayerCreate {
	pc.mutation.SetVanityURL(s)
	return pc
}

// SetNillableVanityURL sets the "vanity_url" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableVanityURL(s *string) *PlayerCreate {
	if s != nil {
		pc.SetVanityURL(*s)
	}
	return pc
}

// SetVanityURLReal sets the "vanity_url_real" field.
func (pc *PlayerCreate) SetVanityURLReal(s string) *PlayerCreate {
	pc.mutation.SetVanityURLReal(s)
	return pc
}

// SetNillableVanityURLReal sets the "vanity_url_real" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableVanityURLReal(s *string) *PlayerCreate {
	if s != nil {
		pc.SetVanityURLReal(*s)
	}
	return pc
}

// SetVacDate sets the "vac_date" field.
func (pc *PlayerCreate) SetVacDate(t time.Time) *PlayerCreate {
	pc.mutation.SetVacDate(t)
	return pc
}

// SetNillableVacDate sets the "vac_date" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableVacDate(t *time.Time) *PlayerCreate {
	if t != nil {
		pc.SetVacDate(*t)
	}
	return pc
}

// SetVacCount sets the "vac_count" field.
func (pc *PlayerCreate) SetVacCount(i int) *PlayerCreate {
	pc.mutation.SetVacCount(i)
	return pc
}

// SetNillableVacCount sets the "vac_count" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableVacCount(i *int) *PlayerCreate {
	if i != nil {
		pc.SetVacCount(*i)
	}
	return pc
}

// SetGameBanDate sets the "game_ban_date" field.
func (pc *PlayerCreate) SetGameBanDate(t time.Time) *PlayerCreate {
	pc.mutation.SetGameBanDate(t)
	return pc
}

// SetNillableGameBanDate sets the "game_ban_date" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableGameBanDate(t *time.Time) *PlayerCreate {
	if t != nil {
		pc.SetGameBanDate(*t)
	}
	return pc
}

// SetGameBanCount sets the "game_ban_count" field.
func (pc *PlayerCreate) SetGameBanCount(i int) *PlayerCreate {
	pc.mutation.SetGameBanCount(i)
	return pc
}

// SetNillableGameBanCount sets the "game_ban_count" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableGameBanCount(i *int) *PlayerCreate {
	if i != nil {
		pc.SetGameBanCount(*i)
	}
	return pc
}

// SetSteamUpdated sets the "steam_updated" field.
func (pc *PlayerCreate) SetSteamUpdated(t time.Time) *PlayerCreate {
	pc.mutation.SetSteamUpdated(t)
	return pc
}

// SetNillableSteamUpdated sets the "steam_updated" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableSteamUpdated(t *time.Time) *PlayerCreate {
	if t != nil {
		pc.SetSteamUpdated(*t)
	}
	return pc
}

// SetSharecodeUpdated sets the "sharecode_updated" field.
func (pc *PlayerCreate) SetSharecodeUpdated(t time.Time) *PlayerCreate {
	pc.mutation.SetSharecodeUpdated(t)
	return pc
}

// SetNillableSharecodeUpdated sets the "sharecode_updated" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableSharecodeUpdated(t *time.Time) *PlayerCreate {
	if t != nil {
		pc.SetSharecodeUpdated(*t)
	}
	return pc
}

// SetAuthCode sets the "auth_code" field.
func (pc *PlayerCreate) SetAuthCode(s string) *PlayerCreate {
	pc.mutation.SetAuthCode(s)
	return pc
}

// SetNillableAuthCode sets the "auth_code" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableAuthCode(s *string) *PlayerCreate {
	if s != nil {
		pc.SetAuthCode(*s)
	}
	return pc
}

// SetProfileCreated sets the "profile_created" field.
func (pc *PlayerCreate) SetProfileCreated(t time.Time) *PlayerCreate {
	pc.mutation.SetProfileCreated(t)
	return pc
}

// SetNillableProfileCreated sets the "profile_created" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableProfileCreated(t *time.Time) *PlayerCreate {
	if t != nil {
		pc.SetProfileCreated(*t)
	}
	return pc
}

// SetOldestSharecodeSeen sets the "oldest_sharecode_seen" field.
func (pc *PlayerCreate) SetOldestSharecodeSeen(s string) *PlayerCreate {
	pc.mutation.SetOldestSharecodeSeen(s)
	return pc
}

// SetNillableOldestSharecodeSeen sets the "oldest_sharecode_seen" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableOldestSharecodeSeen(s *string) *PlayerCreate {
	if s != nil {
		pc.SetOldestSharecodeSeen(*s)
	}
	return pc
}

// SetWins sets the "wins" field.
func (pc *PlayerCreate) SetWins(i int) *PlayerCreate {
	pc.mutation.SetWins(i)
	return pc
}

// SetNillableWins sets the "wins" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableWins(i *int) *PlayerCreate {
	if i != nil {
		pc.SetWins(*i)
	}
	return pc
}

// SetLooses sets the "looses" field.
func (pc *PlayerCreate) SetLooses(i int) *PlayerCreate {
	pc.mutation.SetLooses(i)
	return pc
}

// SetNillableLooses sets the "looses" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableLooses(i *int) *PlayerCreate {
	if i != nil {
		pc.SetLooses(*i)
	}
	return pc
}

// SetTies sets the "ties" field.
func (pc *PlayerCreate) SetTies(i int) *PlayerCreate {
	pc.mutation.SetTies(i)
	return pc
}

// SetNillableTies sets the "ties" field if the given value is not nil.
func (pc *PlayerCreate) SetNillableTies(i *int) *PlayerCreate {
	if i != nil {
		pc.SetTies(*i)
	}
	return pc
}

// SetID sets the "id" field.
func (pc *PlayerCreate) SetID(u uint64) *PlayerCreate {
	pc.mutation.SetID(u)
	return pc
}

// AddStatIDs adds the "stats" edge to the MatchPlayer entity by IDs.
func (pc *PlayerCreate) AddStatIDs(ids ...int) *PlayerCreate {
	pc.mutation.AddStatIDs(ids...)
	return pc
}

// AddStats adds the "stats" edges to the MatchPlayer entity.
func (pc *PlayerCreate) AddStats(m ...*MatchPlayer) *PlayerCreate {
	ids := make([]int, len(m))
	for i := range m {
		ids[i] = m[i].ID
	}
	return pc.AddStatIDs(ids...)
}

// AddMatchIDs adds the "matches" edge to the Match entity by IDs.
func (pc *PlayerCreate) AddMatchIDs(ids ...uint64) *PlayerCreate {
	pc.mutation.AddMatchIDs(ids...)
	return pc
}

// AddMatches adds the "matches" edges to the Match entity.
func (pc *PlayerCreate) AddMatches(m ...*Match) *PlayerCreate {
	ids := make([]uint64, len(m))
	for i := range m {
		ids[i] = m[i].ID
	}
	return pc.AddMatchIDs(ids...)
}

// Mutation returns the PlayerMutation object of the builder.
func (pc *PlayerCreate) Mutation() *PlayerMutation {
	return pc.mutation
}

// Save creates the Player in the database.
func (pc *PlayerCreate) Save(ctx context.Context) (*Player, error) {
	pc.defaults()
	return withHooks(ctx, pc.sqlSave, pc.mutation, pc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (pc *PlayerCreate) SaveX(ctx context.Context) *Player {
	v, err := pc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (pc *PlayerCreate) Exec(ctx context.Context) error {
	_, err := pc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pc *PlayerCreate) ExecX(ctx context.Context) {
	if err := pc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (pc *PlayerCreate) defaults() {
	if _, ok := pc.mutation.SteamUpdated(); !ok {
		v := player.DefaultSteamUpdated()
		pc.mutation.SetSteamUpdated(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (pc *PlayerCreate) check() error {
	if _, ok := pc.mutation.SteamUpdated(); !ok {
		return &ValidationError{Name: "steam_updated", err: errors.New(`ent: missing required field "Player.steam_updated"`)}
	}
	return nil
}

func (pc *PlayerCreate) sqlSave(ctx context.Context) (*Player, error) {
	if err := pc.check(); err != nil {
		return nil, err
	}
	_node, _spec := pc.createSpec()
	if err := sqlgraph.CreateNode(ctx, pc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = uint64(id)
	}
	pc.mutation.id = &_node.ID
	pc.mutation.done = true
	return _node, nil
}

func (pc *PlayerCreate) createSpec() (*Player, *sqlgraph.CreateSpec) {
	var (
		_node = &Player{config: pc.config}
		_spec = sqlgraph.NewCreateSpec(player.Table, sqlgraph.NewFieldSpec(player.FieldID, field.TypeUint64))
	)
	if id, ok := pc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := pc.mutation.Name(); ok {
		_spec.SetField(player.FieldName, field.TypeString, value)
		_node.Name = value
	}
	if value, ok := pc.mutation.Avatar(); ok {
		_spec.SetField(player.FieldAvatar, field.TypeString, value)
		_node.Avatar = value
	}
	if value, ok := pc.mutation.VanityURL(); ok {
		_spec.SetField(player.FieldVanityURL, field.TypeString, value)
		_node.VanityURL = value
	}
	if value, ok := pc.mutation.VanityURLReal(); ok {
		_spec.SetField(player.FieldVanityURLReal, field.TypeString, value)
		_node.VanityURLReal = value
	}
	if value, ok := pc.mutation.VacDate(); ok {
		_spec.SetField(player.FieldVacDate, field.TypeTime, value)
		_node.VacDate = value
	}
	if value, ok := pc.mutation.VacCount(); ok {
		_spec.SetField(player.FieldVacCount, field.TypeInt, value)
		_node.VacCount = value
	}
	if value, ok := pc.mutation.GameBanDate(); ok {
		_spec.SetField(player.FieldGameBanDate, field.TypeTime, value)
		_node.GameBanDate = value
	}
	if value, ok := pc.mutation.GameBanCount(); ok {
		_spec.SetField(player.FieldGameBanCount, field.TypeInt, value)
		_node.GameBanCount = value
	}
	if value, ok := pc.mutation.SteamUpdated(); ok {
		_spec.SetField(player.FieldSteamUpdated, field.TypeTime, value)
		_node.SteamUpdated = value
	}
	if value, ok := pc.mutation.SharecodeUpdated(); ok {
		_spec.SetField(player.FieldSharecodeUpdated, field.TypeTime, value)
		_node.SharecodeUpdated = value
	}
	if value, ok := pc.mutation.AuthCode(); ok {
		_spec.SetField(player.FieldAuthCode, field.TypeString, value)
		_node.AuthCode = value
	}
	if value, ok := pc.mutation.ProfileCreated(); ok {
		_spec.SetField(player.FieldProfileCreated, field.TypeTime, value)
		_node.ProfileCreated = value
	}
	if value, ok := pc.mutation.OldestSharecodeSeen(); ok {
		_spec.SetField(player.FieldOldestSharecodeSeen, field.TypeString, value)
		_node.OldestSharecodeSeen = value
	}
	if value, ok := pc.mutation.Wins(); ok {
		_spec.SetField(player.FieldWins, field.TypeInt, value)
		_node.Wins = value
	}
	if value, ok := pc.mutation.Looses(); ok {
		_spec.SetField(player.FieldLooses, field.TypeInt, value)
		_node.Looses = value
	}
	if value, ok := pc.mutation.Ties(); ok {
		_spec.SetField(player.FieldTies, field.TypeInt, value)
		_node.Ties = value
	}
	if nodes := pc.mutation.StatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   player.StatsTable,
			Columns: []string{player.StatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(matchplayer.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.MatchesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   player.MatchesTable,
			Columns: player.MatchesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(match.FieldID, field.TypeUint64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// PlayerCreateBulk is the builder for creating many Player entities in bulk.
type PlayerCreateBulk struct {
	config
	builders []*PlayerCreate
}

// Save creates the Player entities in the database.
func (pcb *PlayerCreateBulk) Save(ctx context.Context) ([]*Player, error) {
	specs := make([]*sqlgraph.CreateSpec, len(pcb.builders))
	nodes := make([]*Player, len(pcb.builders))
	mutators := make([]Mutator, len(pcb.builders))
	for i := range pcb.builders {
		func(i int, root context.Context) {
			builder := pcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*PlayerMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, pcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, pcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = uint64(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, pcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (pcb *PlayerCreateBulk) SaveX(ctx context.Context) []*Player {
	v, err := pcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (pcb *PlayerCreateBulk) Exec(ctx context.Context) error {
	_, err := pcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pcb *PlayerCreateBulk) ExecX(ctx context.Context) {
	if err := pcb.Exec(ctx); err != nil {
		panic(err)
	}
}
