// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"somegit.dev/csgowtf/csgowtfd/ent/matchplayer"
	"somegit.dev/csgowtf/csgowtfd/ent/roundstats"
)

// RoundStatsCreate is the builder for creating a RoundStats entity.
type RoundStatsCreate struct {
	config
	mutation *RoundStatsMutation
	hooks    []Hook
}

// SetRound sets the "round" field.
func (rsc *RoundStatsCreate) SetRound(u uint) *RoundStatsCreate {
	rsc.mutation.SetRound(u)
	return rsc
}

// SetBank sets the "bank" field.
func (rsc *RoundStatsCreate) SetBank(u uint) *RoundStatsCreate {
	rsc.mutation.SetBank(u)
	return rsc
}

// SetEquipment sets the "equipment" field.
func (rsc *RoundStatsCreate) SetEquipment(u uint) *RoundStatsCreate {
	rsc.mutation.SetEquipment(u)
	return rsc
}

// SetSpent sets the "spent" field.
func (rsc *RoundStatsCreate) SetSpent(u uint) *RoundStatsCreate {
	rsc.mutation.SetSpent(u)
	return rsc
}

// SetMatchPlayerID sets the "match_player" edge to the MatchPlayer entity by ID.
func (rsc *RoundStatsCreate) SetMatchPlayerID(id int) *RoundStatsCreate {
	rsc.mutation.SetMatchPlayerID(id)
	return rsc
}

// SetNillableMatchPlayerID sets the "match_player" edge to the MatchPlayer entity by ID if the given value is not nil.
func (rsc *RoundStatsCreate) SetNillableMatchPlayerID(id *int) *RoundStatsCreate {
	if id != nil {
		rsc = rsc.SetMatchPlayerID(*id)
	}
	return rsc
}

// SetMatchPlayer sets the "match_player" edge to the MatchPlayer entity.
func (rsc *RoundStatsCreate) SetMatchPlayer(m *MatchPlayer) *RoundStatsCreate {
	return rsc.SetMatchPlayerID(m.ID)
}

// Mutation returns the RoundStatsMutation object of the builder.
func (rsc *RoundStatsCreate) Mutation() *RoundStatsMutation {
	return rsc.mutation
}

// Save creates the RoundStats in the database.
func (rsc *RoundStatsCreate) Save(ctx context.Context) (*RoundStats, error) {
	return withHooks(ctx, rsc.sqlSave, rsc.mutation, rsc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (rsc *RoundStatsCreate) SaveX(ctx context.Context) *RoundStats {
	v, err := rsc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (rsc *RoundStatsCreate) Exec(ctx context.Context) error {
	_, err := rsc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (rsc *RoundStatsCreate) ExecX(ctx context.Context) {
	if err := rsc.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (rsc *RoundStatsCreate) check() error {
	if _, ok := rsc.mutation.Round(); !ok {
		return &ValidationError{Name: "round", err: errors.New(`ent: missing required field "RoundStats.round"`)}
	}
	if _, ok := rsc.mutation.Bank(); !ok {
		return &ValidationError{Name: "bank", err: errors.New(`ent: missing required field "RoundStats.bank"`)}
	}
	if _, ok := rsc.mutation.Equipment(); !ok {
		return &ValidationError{Name: "equipment", err: errors.New(`ent: missing required field "RoundStats.equipment"`)}
	}
	if _, ok := rsc.mutation.Spent(); !ok {
		return &ValidationError{Name: "spent", err: errors.New(`ent: missing required field "RoundStats.spent"`)}
	}
	return nil
}

func (rsc *RoundStatsCreate) sqlSave(ctx context.Context) (*RoundStats, error) {
	if err := rsc.check(); err != nil {
		return nil, err
	}
	_node, _spec := rsc.createSpec()
	if err := sqlgraph.CreateNode(ctx, rsc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	rsc.mutation.id = &_node.ID
	rsc.mutation.done = true
	return _node, nil
}

func (rsc *RoundStatsCreate) createSpec() (*RoundStats, *sqlgraph.CreateSpec) {
	var (
		_node = &RoundStats{config: rsc.config}
		_spec = sqlgraph.NewCreateSpec(roundstats.Table, sqlgraph.NewFieldSpec(roundstats.FieldID, field.TypeInt))
	)
	if value, ok := rsc.mutation.Round(); ok {
		_spec.SetField(roundstats.FieldRound, field.TypeUint, value)
		_node.Round = value
	}
	if value, ok := rsc.mutation.Bank(); ok {
		_spec.SetField(roundstats.FieldBank, field.TypeUint, value)
		_node.Bank = value
	}
	if value, ok := rsc.mutation.Equipment(); ok {
		_spec.SetField(roundstats.FieldEquipment, field.TypeUint, value)
		_node.Equipment = value
	}
	if value, ok := rsc.mutation.Spent(); ok {
		_spec.SetField(roundstats.FieldSpent, field.TypeUint, value)
		_node.Spent = value
	}
	if nodes := rsc.mutation.MatchPlayerIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   roundstats.MatchPlayerTable,
			Columns: []string{roundstats.MatchPlayerColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(matchplayer.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.match_player_round_stats = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// RoundStatsCreateBulk is the builder for creating many RoundStats entities in bulk.
type RoundStatsCreateBulk struct {
	config
	builders []*RoundStatsCreate
}

// Save creates the RoundStats entities in the database.
func (rscb *RoundStatsCreateBulk) Save(ctx context.Context) ([]*RoundStats, error) {
	specs := make([]*sqlgraph.CreateSpec, len(rscb.builders))
	nodes := make([]*RoundStats, len(rscb.builders))
	mutators := make([]Mutator, len(rscb.builders))
	for i := range rscb.builders {
		func(i int, root context.Context) {
			builder := rscb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*RoundStatsMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, rscb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, rscb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, rscb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (rscb *RoundStatsCreateBulk) SaveX(ctx context.Context) []*RoundStats {
	v, err := rscb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (rscb *RoundStatsCreateBulk) Exec(ctx context.Context) error {
	_, err := rscb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (rscb *RoundStatsCreateBulk) ExecX(ctx context.Context) {
	if err := rscb.Exec(ctx); err != nil {
		panic(err)
	}
}
