// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"somegit.dev/csgowtf/csgowtfd/ent/matchplayer"
	"somegit.dev/csgowtf/csgowtfd/ent/predicate"
	"somegit.dev/csgowtf/csgowtfd/ent/roundstats"
)

// RoundStatsQuery is the builder for querying RoundStats entities.
type RoundStatsQuery struct {
	config
	ctx             *QueryContext
	order           []roundstats.OrderOption
	inters          []Interceptor
	predicates      []predicate.RoundStats
	withMatchPlayer *MatchPlayerQuery
	withFKs         bool
	modifiers       []func(*sql.Selector)
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the RoundStatsQuery builder.
func (rsq *RoundStatsQuery) Where(ps ...predicate.RoundStats) *RoundStatsQuery {
	rsq.predicates = append(rsq.predicates, ps...)
	return rsq
}

// Limit the number of records to be returned by this query.
func (rsq *RoundStatsQuery) Limit(limit int) *RoundStatsQuery {
	rsq.ctx.Limit = &limit
	return rsq
}

// Offset to start from.
func (rsq *RoundStatsQuery) Offset(offset int) *RoundStatsQuery {
	rsq.ctx.Offset = &offset
	return rsq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (rsq *RoundStatsQuery) Unique(unique bool) *RoundStatsQuery {
	rsq.ctx.Unique = &unique
	return rsq
}

// Order specifies how the records should be ordered.
func (rsq *RoundStatsQuery) Order(o ...roundstats.OrderOption) *RoundStatsQuery {
	rsq.order = append(rsq.order, o...)
	return rsq
}

// QueryMatchPlayer chains the current query on the "match_player" edge.
func (rsq *RoundStatsQuery) QueryMatchPlayer() *MatchPlayerQuery {
	query := (&MatchPlayerClient{config: rsq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rsq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rsq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(roundstats.Table, roundstats.FieldID, selector),
			sqlgraph.To(matchplayer.Table, matchplayer.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, roundstats.MatchPlayerTable, roundstats.MatchPlayerColumn),
		)
		fromU = sqlgraph.SetNeighbors(rsq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first RoundStats entity from the query.
// Returns a *NotFoundError when no RoundStats was found.
func (rsq *RoundStatsQuery) First(ctx context.Context) (*RoundStats, error) {
	nodes, err := rsq.Limit(1).All(setContextOp(ctx, rsq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{roundstats.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (rsq *RoundStatsQuery) FirstX(ctx context.Context) *RoundStats {
	node, err := rsq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first RoundStats ID from the query.
// Returns a *NotFoundError when no RoundStats ID was found.
func (rsq *RoundStatsQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = rsq.Limit(1).IDs(setContextOp(ctx, rsq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{roundstats.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (rsq *RoundStatsQuery) FirstIDX(ctx context.Context) int {
	id, err := rsq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single RoundStats entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one RoundStats entity is found.
// Returns a *NotFoundError when no RoundStats entities are found.
func (rsq *RoundStatsQuery) Only(ctx context.Context) (*RoundStats, error) {
	nodes, err := rsq.Limit(2).All(setContextOp(ctx, rsq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{roundstats.Label}
	default:
		return nil, &NotSingularError{roundstats.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (rsq *RoundStatsQuery) OnlyX(ctx context.Context) *RoundStats {
	node, err := rsq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only RoundStats ID in the query.
// Returns a *NotSingularError when more than one RoundStats ID is found.
// Returns a *NotFoundError when no entities are found.
func (rsq *RoundStatsQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = rsq.Limit(2).IDs(setContextOp(ctx, rsq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{roundstats.Label}
	default:
		err = &NotSingularError{roundstats.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (rsq *RoundStatsQuery) OnlyIDX(ctx context.Context) int {
	id, err := rsq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of RoundStatsSlice.
func (rsq *RoundStatsQuery) All(ctx context.Context) ([]*RoundStats, error) {
	ctx = setContextOp(ctx, rsq.ctx, "All")
	if err := rsq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*RoundStats, *RoundStatsQuery]()
	return withInterceptors[[]*RoundStats](ctx, rsq, qr, rsq.inters)
}

// AllX is like All, but panics if an error occurs.
func (rsq *RoundStatsQuery) AllX(ctx context.Context) []*RoundStats {
	nodes, err := rsq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of RoundStats IDs.
func (rsq *RoundStatsQuery) IDs(ctx context.Context) (ids []int, err error) {
	if rsq.ctx.Unique == nil && rsq.path != nil {
		rsq.Unique(true)
	}
	ctx = setContextOp(ctx, rsq.ctx, "IDs")
	if err = rsq.Select(roundstats.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (rsq *RoundStatsQuery) IDsX(ctx context.Context) []int {
	ids, err := rsq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (rsq *RoundStatsQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, rsq.ctx, "Count")
	if err := rsq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, rsq, querierCount[*RoundStatsQuery](), rsq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (rsq *RoundStatsQuery) CountX(ctx context.Context) int {
	count, err := rsq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (rsq *RoundStatsQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, rsq.ctx, "Exist")
	switch _, err := rsq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (rsq *RoundStatsQuery) ExistX(ctx context.Context) bool {
	exist, err := rsq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the RoundStatsQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (rsq *RoundStatsQuery) Clone() *RoundStatsQuery {
	if rsq == nil {
		return nil
	}
	return &RoundStatsQuery{
		config:          rsq.config,
		ctx:             rsq.ctx.Clone(),
		order:           append([]roundstats.OrderOption{}, rsq.order...),
		inters:          append([]Interceptor{}, rsq.inters...),
		predicates:      append([]predicate.RoundStats{}, rsq.predicates...),
		withMatchPlayer: rsq.withMatchPlayer.Clone(),
		// clone intermediate query.
		sql:  rsq.sql.Clone(),
		path: rsq.path,
	}
}

// WithMatchPlayer tells the query-builder to eager-load the nodes that are connected to
// the "match_player" edge. The optional arguments are used to configure the query builder of the edge.
func (rsq *RoundStatsQuery) WithMatchPlayer(opts ...func(*MatchPlayerQuery)) *RoundStatsQuery {
	query := (&MatchPlayerClient{config: rsq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	rsq.withMatchPlayer = query
	return rsq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Round uint `json:"round,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.RoundStats.Query().
//		GroupBy(roundstats.FieldRound).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (rsq *RoundStatsQuery) GroupBy(field string, fields ...string) *RoundStatsGroupBy {
	rsq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &RoundStatsGroupBy{build: rsq}
	grbuild.flds = &rsq.ctx.Fields
	grbuild.label = roundstats.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Round uint `json:"round,omitempty"`
//	}
//
//	client.RoundStats.Query().
//		Select(roundstats.FieldRound).
//		Scan(ctx, &v)
func (rsq *RoundStatsQuery) Select(fields ...string) *RoundStatsSelect {
	rsq.ctx.Fields = append(rsq.ctx.Fields, fields...)
	sbuild := &RoundStatsSelect{RoundStatsQuery: rsq}
	sbuild.label = roundstats.Label
	sbuild.flds, sbuild.scan = &rsq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a RoundStatsSelect configured with the given aggregations.
func (rsq *RoundStatsQuery) Aggregate(fns ...AggregateFunc) *RoundStatsSelect {
	return rsq.Select().Aggregate(fns...)
}

func (rsq *RoundStatsQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range rsq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, rsq); err != nil {
				return err
			}
		}
	}
	for _, f := range rsq.ctx.Fields {
		if !roundstats.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if rsq.path != nil {
		prev, err := rsq.path(ctx)
		if err != nil {
			return err
		}
		rsq.sql = prev
	}
	return nil
}

func (rsq *RoundStatsQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*RoundStats, error) {
	var (
		nodes       = []*RoundStats{}
		withFKs     = rsq.withFKs
		_spec       = rsq.querySpec()
		loadedTypes = [1]bool{
			rsq.withMatchPlayer != nil,
		}
	)
	if rsq.withMatchPlayer != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, roundstats.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*RoundStats).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &RoundStats{config: rsq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if len(rsq.modifiers) > 0 {
		_spec.Modifiers = rsq.modifiers
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, rsq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := rsq.withMatchPlayer; query != nil {
		if err := rsq.loadMatchPlayer(ctx, query, nodes, nil,
			func(n *RoundStats, e *MatchPlayer) { n.Edges.MatchPlayer = e }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (rsq *RoundStatsQuery) loadMatchPlayer(ctx context.Context, query *MatchPlayerQuery, nodes []*RoundStats, init func(*RoundStats), assign func(*RoundStats, *MatchPlayer)) error {
	ids := make([]int, 0, len(nodes))
	nodeids := make(map[int][]*RoundStats)
	for i := range nodes {
		if nodes[i].match_player_round_stats == nil {
			continue
		}
		fk := *nodes[i].match_player_round_stats
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(matchplayer.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "match_player_round_stats" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}

func (rsq *RoundStatsQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := rsq.querySpec()
	if len(rsq.modifiers) > 0 {
		_spec.Modifiers = rsq.modifiers
	}
	_spec.Node.Columns = rsq.ctx.Fields
	if len(rsq.ctx.Fields) > 0 {
		_spec.Unique = rsq.ctx.Unique != nil && *rsq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, rsq.driver, _spec)
}

func (rsq *RoundStatsQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(roundstats.Table, roundstats.Columns, sqlgraph.NewFieldSpec(roundstats.FieldID, field.TypeInt))
	_spec.From = rsq.sql
	if unique := rsq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if rsq.path != nil {
		_spec.Unique = true
	}
	if fields := rsq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, roundstats.FieldID)
		for i := range fields {
			if fields[i] != roundstats.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := rsq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := rsq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := rsq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := rsq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (rsq *RoundStatsQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(rsq.driver.Dialect())
	t1 := builder.Table(roundstats.Table)
	columns := rsq.ctx.Fields
	if len(columns) == 0 {
		columns = roundstats.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if rsq.sql != nil {
		selector = rsq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if rsq.ctx.Unique != nil && *rsq.ctx.Unique {
		selector.Distinct()
	}
	for _, m := range rsq.modifiers {
		m(selector)
	}
	for _, p := range rsq.predicates {
		p(selector)
	}
	for _, p := range rsq.order {
		p(selector)
	}
	if offset := rsq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := rsq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// Modify adds a query modifier for attaching custom logic to queries.
func (rsq *RoundStatsQuery) Modify(modifiers ...func(s *sql.Selector)) *RoundStatsSelect {
	rsq.modifiers = append(rsq.modifiers, modifiers...)
	return rsq.Select()
}

// RoundStatsGroupBy is the group-by builder for RoundStats entities.
type RoundStatsGroupBy struct {
	selector
	build *RoundStatsQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (rsgb *RoundStatsGroupBy) Aggregate(fns ...AggregateFunc) *RoundStatsGroupBy {
	rsgb.fns = append(rsgb.fns, fns...)
	return rsgb
}

// Scan applies the selector query and scans the result into the given value.
func (rsgb *RoundStatsGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, rsgb.build.ctx, "GroupBy")
	if err := rsgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*RoundStatsQuery, *RoundStatsGroupBy](ctx, rsgb.build, rsgb, rsgb.build.inters, v)
}

func (rsgb *RoundStatsGroupBy) sqlScan(ctx context.Context, root *RoundStatsQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(rsgb.fns))
	for _, fn := range rsgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*rsgb.flds)+len(rsgb.fns))
		for _, f := range *rsgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*rsgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := rsgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// RoundStatsSelect is the builder for selecting fields of RoundStats entities.
type RoundStatsSelect struct {
	*RoundStatsQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (rss *RoundStatsSelect) Aggregate(fns ...AggregateFunc) *RoundStatsSelect {
	rss.fns = append(rss.fns, fns...)
	return rss
}

// Scan applies the selector query and scans the result into the given value.
func (rss *RoundStatsSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, rss.ctx, "Select")
	if err := rss.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*RoundStatsQuery, *RoundStatsSelect](ctx, rss.RoundStatsQuery, rss, rss.inters, v)
}

func (rss *RoundStatsSelect) sqlScan(ctx context.Context, root *RoundStatsQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(rss.fns))
	for _, fn := range rss.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*rss.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := rss.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// Modify adds a query modifier for attaching custom logic to queries.
func (rss *RoundStatsSelect) Modify(modifiers ...func(s *sql.Selector)) *RoundStatsSelect {
	rss.modifiers = append(rss.modifiers, modifiers...)
	return rss
}
